// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from plansys2_msgs:srv/GetProblemInstanceDetails.idl
// generated code does not contain a copyright notice

#ifndef PLANSYS2_MSGS__SRV__DETAIL__GET_PROBLEM_INSTANCE_DETAILS__FUNCTIONS_H_
#define PLANSYS2_MSGS__SRV__DETAIL__GET_PROBLEM_INSTANCE_DETAILS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "plansys2_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "plansys2_msgs/srv/detail/get_problem_instance_details__struct.h"

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_type_hash_t *
plansys2_msgs__srv__GetProblemInstanceDetails__get_type_hash(
  const rosidl_service_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeDescription *
plansys2_msgs__srv__GetProblemInstanceDetails__get_type_description(
  const rosidl_service_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeSource *
plansys2_msgs__srv__GetProblemInstanceDetails__get_individual_type_description_source(
  const rosidl_service_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
plansys2_msgs__srv__GetProblemInstanceDetails__get_type_description_sources(
  const rosidl_service_type_support_t * type_support);

/// Initialize srv/GetProblemInstanceDetails message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * plansys2_msgs__srv__GetProblemInstanceDetails_Request
 * )) before or use
 * plansys2_msgs__srv__GetProblemInstanceDetails_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Request__init(plansys2_msgs__srv__GetProblemInstanceDetails_Request * msg);

/// Finalize srv/GetProblemInstanceDetails message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Request__fini(plansys2_msgs__srv__GetProblemInstanceDetails_Request * msg);

/// Create srv/GetProblemInstanceDetails message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
plansys2_msgs__srv__GetProblemInstanceDetails_Request *
plansys2_msgs__srv__GetProblemInstanceDetails_Request__create();

/// Destroy srv/GetProblemInstanceDetails message.
/**
 * It calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Request__destroy(plansys2_msgs__srv__GetProblemInstanceDetails_Request * msg);

/// Check for srv/GetProblemInstanceDetails message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Request__are_equal(const plansys2_msgs__srv__GetProblemInstanceDetails_Request * lhs, const plansys2_msgs__srv__GetProblemInstanceDetails_Request * rhs);

/// Copy a srv/GetProblemInstanceDetails message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Request__copy(
  const plansys2_msgs__srv__GetProblemInstanceDetails_Request * input,
  plansys2_msgs__srv__GetProblemInstanceDetails_Request * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_type_hash_t *
plansys2_msgs__srv__GetProblemInstanceDetails_Request__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeDescription *
plansys2_msgs__srv__GetProblemInstanceDetails_Request__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeSource *
plansys2_msgs__srv__GetProblemInstanceDetails_Request__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
plansys2_msgs__srv__GetProblemInstanceDetails_Request__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of srv/GetProblemInstanceDetails messages.
/**
 * It allocates the memory for the number of elements and calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence__init(plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence * array, size_t size);

/// Finalize array of srv/GetProblemInstanceDetails messages.
/**
 * It calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence__fini(plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence * array);

/// Create array of srv/GetProblemInstanceDetails messages.
/**
 * It allocates the memory for the array and calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence *
plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence__create(size_t size);

/// Destroy array of srv/GetProblemInstanceDetails messages.
/**
 * It calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence__destroy(plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence * array);

/// Check for srv/GetProblemInstanceDetails message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence__are_equal(const plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence * lhs, const plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence * rhs);

/// Copy an array of srv/GetProblemInstanceDetails messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence__copy(
  const plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence * input,
  plansys2_msgs__srv__GetProblemInstanceDetails_Request__Sequence * output);

/// Initialize srv/GetProblemInstanceDetails message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * plansys2_msgs__srv__GetProblemInstanceDetails_Response
 * )) before or use
 * plansys2_msgs__srv__GetProblemInstanceDetails_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Response__init(plansys2_msgs__srv__GetProblemInstanceDetails_Response * msg);

/// Finalize srv/GetProblemInstanceDetails message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Response__fini(plansys2_msgs__srv__GetProblemInstanceDetails_Response * msg);

/// Create srv/GetProblemInstanceDetails message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
plansys2_msgs__srv__GetProblemInstanceDetails_Response *
plansys2_msgs__srv__GetProblemInstanceDetails_Response__create();

/// Destroy srv/GetProblemInstanceDetails message.
/**
 * It calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Response__destroy(plansys2_msgs__srv__GetProblemInstanceDetails_Response * msg);

/// Check for srv/GetProblemInstanceDetails message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Response__are_equal(const plansys2_msgs__srv__GetProblemInstanceDetails_Response * lhs, const plansys2_msgs__srv__GetProblemInstanceDetails_Response * rhs);

/// Copy a srv/GetProblemInstanceDetails message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Response__copy(
  const plansys2_msgs__srv__GetProblemInstanceDetails_Response * input,
  plansys2_msgs__srv__GetProblemInstanceDetails_Response * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_type_hash_t *
plansys2_msgs__srv__GetProblemInstanceDetails_Response__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeDescription *
plansys2_msgs__srv__GetProblemInstanceDetails_Response__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeSource *
plansys2_msgs__srv__GetProblemInstanceDetails_Response__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
plansys2_msgs__srv__GetProblemInstanceDetails_Response__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of srv/GetProblemInstanceDetails messages.
/**
 * It allocates the memory for the number of elements and calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence__init(plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence * array, size_t size);

/// Finalize array of srv/GetProblemInstanceDetails messages.
/**
 * It calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence__fini(plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence * array);

/// Create array of srv/GetProblemInstanceDetails messages.
/**
 * It allocates the memory for the array and calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence *
plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence__create(size_t size);

/// Destroy array of srv/GetProblemInstanceDetails messages.
/**
 * It calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence__destroy(plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence * array);

/// Check for srv/GetProblemInstanceDetails message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence__are_equal(const plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence * lhs, const plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence * rhs);

/// Copy an array of srv/GetProblemInstanceDetails messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence__copy(
  const plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence * input,
  plansys2_msgs__srv__GetProblemInstanceDetails_Response__Sequence * output);

/// Initialize srv/GetProblemInstanceDetails message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * plansys2_msgs__srv__GetProblemInstanceDetails_Event
 * )) before or use
 * plansys2_msgs__srv__GetProblemInstanceDetails_Event__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Event__init(plansys2_msgs__srv__GetProblemInstanceDetails_Event * msg);

/// Finalize srv/GetProblemInstanceDetails message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Event__fini(plansys2_msgs__srv__GetProblemInstanceDetails_Event * msg);

/// Create srv/GetProblemInstanceDetails message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Event__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
plansys2_msgs__srv__GetProblemInstanceDetails_Event *
plansys2_msgs__srv__GetProblemInstanceDetails_Event__create();

/// Destroy srv/GetProblemInstanceDetails message.
/**
 * It calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Event__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Event__destroy(plansys2_msgs__srv__GetProblemInstanceDetails_Event * msg);

/// Check for srv/GetProblemInstanceDetails message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Event__are_equal(const plansys2_msgs__srv__GetProblemInstanceDetails_Event * lhs, const plansys2_msgs__srv__GetProblemInstanceDetails_Event * rhs);

/// Copy a srv/GetProblemInstanceDetails message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Event__copy(
  const plansys2_msgs__srv__GetProblemInstanceDetails_Event * input,
  plansys2_msgs__srv__GetProblemInstanceDetails_Event * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_type_hash_t *
plansys2_msgs__srv__GetProblemInstanceDetails_Event__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeDescription *
plansys2_msgs__srv__GetProblemInstanceDetails_Event__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeSource *
plansys2_msgs__srv__GetProblemInstanceDetails_Event__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
plansys2_msgs__srv__GetProblemInstanceDetails_Event__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of srv/GetProblemInstanceDetails messages.
/**
 * It allocates the memory for the number of elements and calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Event__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence__init(plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence * array, size_t size);

/// Finalize array of srv/GetProblemInstanceDetails messages.
/**
 * It calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Event__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence__fini(plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence * array);

/// Create array of srv/GetProblemInstanceDetails messages.
/**
 * It allocates the memory for the array and calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence *
plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence__create(size_t size);

/// Destroy array of srv/GetProblemInstanceDetails messages.
/**
 * It calls
 * plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
void
plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence__destroy(plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence * array);

/// Check for srv/GetProblemInstanceDetails message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence__are_equal(const plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence * lhs, const plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence * rhs);

/// Copy an array of srv/GetProblemInstanceDetails messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_plansys2_msgs
bool
plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence__copy(
  const plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence * input,
  plansys2_msgs__srv__GetProblemInstanceDetails_Event__Sequence * output);
#ifdef __cplusplus
}
#endif

#endif  // PLANSYS2_MSGS__SRV__DETAIL__GET_PROBLEM_INSTANCE_DETAILS__FUNCTIONS_H_
